#include <unistd.h>//+
#include <stdio.h> //+
#include <fcntl.h> //+
#include <malloc.h>
#include <linux/fb.h>
#include <sys/mman.h>

#include <asm/types.h>          /* for videodev2.h */
#include <linux/videodev2.h>
#include <pthread.h>
#include <stdlib.h> //+
#include <sys/types.h>
#include <sys/stat.h> //+
#include <errno.h>
#include <string.h> //+
#include <time.h>
#include <sys/time.h>
#include <sys/ioctl.h>

static unsigned char clip(int value)
{
	if (value < 0)
		value = 0;
	else if (value > 255)
		value = 255;
	return value;
}

void * inpfunc(void * arg)
{
 char inch;
 inch=0;
 while (inch!='q')
 {
 inch=getchar();
 *(char*)arg=inch;
 }
 return 0;
}



int main(int argc,char **argv)
{
//cam
  //const char *output_base;
  const char *video_device;
  int fcount=1;
  int dev_fd;
 // int buffer_width;
 // int buffer_height;
  int buffer_size;
  int Ysize,CbCrsize;
  struct v4l2_capability cap;
  struct v4l2_format fmt;
  struct v4l2_control control;
  
  char fourcc[5]={0,0,0,0,0};
  unsigned char **buffers;
  int i;
 // struct timeval start;
 // struct timeval finish;
  //double fps;

//th
  pthread_t key_thread;

  char retkey=0;
//fb
  int fbfd = 0;
  struct fb_var_screeninfo vinfo;
  struct fb_fix_screeninfo finfo;
  long int screensize = 0;
  char *fbp = 0;
  int x = 0, y = 0;
  long int location = 0;
  
//conv ycbcb rgb565 
	int y1, u, v;
	int r1,g1,b1;
	int fxdimm,fydimm;
	long int indY,indCbCr;
	char cR,cB;

  if(argc<3)
  {
    fprintf(stderr,"Usage:%s <device> <width> <height> [<exposure>, set to -1 for auto]\n",argv[0]);
    return 1;
  }
  
	video_device=argv[1];

	memset(&fmt,0,sizeof(fmt));
	fmt.type=V4L2_BUF_TYPE_VIDEO_CAPTURE;
	
	fmt.fmt.pix.width=atoi(argv[2]);
	fmt.fmt.pix.height=atoi(argv[3]);
	

	
        //fmt.fmt.pix.pixelformat=V4l2_PIX_FMT_RGB565 not supported by driver
  if ((dev_fd = open( video_device, O_RDWR)) == -1)
    perror("ERROR opening camera interface\n");  
  
	if (0 != ioctl(dev_fd, VIDIOC_QUERYCAP, &cap)) {
		if (EINVAL == errno) {
			fprintf (stderr, "%s is no V4L2 device\n",video_device);
			return 1;
		} else {
			perror ("VIDIOC_QUERYCAP");
			return 1;
		}
	}
	if (!(cap.capabilities & V4L2_CAP_VIDEO_CAPTURE)) {
		fprintf (stderr, "%s is no video capture device\n",video_device);
		return 1;
	}	
	
	if (!(cap.capabilities & V4L2_CAP_READWRITE)) {
		fprintf (stderr, "%s does not support read i/o\n", video_device);
		return 1;
	}	
	
	if (0 != ioctl (dev_fd, VIDIOC_S_FMT, &fmt))
	{
		perror ("VIDIOC_G_FMT");
		return 1;
	}
	
	
	if (argc>3)
	 {
	 
	  memset (&control,0,sizeof(control));	
	  control.id = V4L2_CID_EXPOSURE_AUTO;
	  control.value=0;
	
	  if( ioctl(dev_fd,VIDIOC_S_CTRL,&control))
	   {
		fprintf(stderr,"Failed to set control autoexpouse");
	   }
	
	  
	  memset (&control,0,sizeof(control));	
	  control.id = V4L2_CID_EXPOSURE;
	  control.value=atoi(argv[4]);
	
	
	  if( ioctl(dev_fd,VIDIOC_S_CTRL,&control))
	   {
		fprintf(stderr,"Failed to set expouse 0");
	   }
	 }
	
	memmove(fourcc,&fmt.fmt.pix.pixelformat,4); //
	
	printf("Goint to capture frames %d x %d format: %4s framesize: %d\n",
				 fmt.fmt.pix.width,
				 fmt.fmt.pix.height,
				 fourcc,
				 fmt.fmt.pix.sizeimage);
								
	
  Ysize=fmt.fmt.pix.width*fmt.fmt.pix.height;
  CbCrsize=fmt.fmt.pix.width*fmt.fmt.pix.height/2;
  buffer_size=fmt.fmt.pix.sizeimage;
	
	fcount=1;
	
	buffers=malloc(sizeof(unsigned char *)*1);
	
	if(!buffers)
	{
		perror("Can't allocate buffer!\n");
		return 1;
	}
	
	//try to allocate memory for all buffers
	
	{
		buffers[0]=malloc(buffer_size);
		
		//	break;
	}
	
	
	
	//fcount=i;

        /* Open the file for reading and writing */
        fbfd = open("/dev/fb0", O_RDWR);
        if (!fbfd) {
                printf("Error: cannot open framebuffer device.\n");
                return -1;
        }
        printf("The framebuffer device was opened successfully.\n");

        /* Get fixed screen information */
        if (ioctl(fbfd, FBIOGET_FSCREENINFO, &finfo)) {
                printf("Error reading fixed information.\n");
                return -1;
        }

        /* Get variable screen information */
        if (ioctl(fbfd, FBIOGET_VSCREENINFO, &vinfo)) {
                printf("Error reading variable information.\n");
                return -1;
        }

        /* Figure out the size of the screen in bytes */
        screensize = vinfo.xres * vinfo.yres * vinfo.bits_per_pixel / 8;
        
        /* Map the device to memory */
        fbp = (char *)mmap(0, screensize, PROT_READ | PROT_WRITE, MAP_SHARED,

                fbfd, 0);
        if ((int)fbp == -1) { printf("Error: failed to map framebuffer device to memory.\n");
       	 return -1;
        }
        printf("The framebuffer device was mapped to memory successfully.\n");
        printf("fb info\n xres %d yres %d BPP %d linelength %d\n",vinfo.xres,vinfo.yres,vinfo.bits_per_pixel,finfo.line_length);


 // printf("About to capture %d images to %s\n",fcount,output_base);
//	gettimeofday(&start,NULL);

	fmt.fmt.pix.width=atoi(argv[2]);
	fmt.fmt.pix.height=atoi(argv[3]);
  
  if (vinfo.yres>fmt.fmt.pix.width)
   {
    fydimm=fmt.fmt.pix.width;
   }
  else
   {
    fydimm=vinfo.yres;
   }

  if (vinfo.xres>fmt.fmt.pix.height)
   {
    fxdimm=fmt.fmt.pix.height;
   }
  else
   {
    fxdimm=vinfo.xres;
   }

//create tread for shell commands  reaction
  if (pthread_create(&key_thread,NULL,inpfunc,&retkey)!=0)
  {
   perror("Application cant create tread for shell input tracking");
   return EXIT_FAILURE;
  }


  do //for(;;)//i=0;i<fcount;i++)
  {
    int rd=0;
    
//    fprintf(stderr,"get frame\n");
    
    if((rd=read(dev_fd, buffers[0], buffer_size))<buffer_size)
    {
      fprintf(stderr,"Expected %d got %d!\n",buffer_size,rd);
      //continue;
    }
    
//    fprintf(stderr,"convert frame %d x %d , buffsize %d \n ",fxdimm,fydimm,Ysize);
    
    indY=0;
    indCbCr=0;
    for(x=0;x<fxdimm;x++)
     for(y=0;y<fydimm;y++)		 /* Where we are going to put the pixel */
	{
//	fprintf(stderr,"K1 - %d\d",indY);
	/* Input format is YCbBCb */
	//Y= *(buffers[i]+0..Ysize)
	//Cb=*(buffers[i]+Ysize+0..CbCrsize)
	//Cr=*(buffers[i]+Ysize+CbCrsize+0..CbCrsize)
		y1 = *(buffers[0]+indY);
		indY++;
//	fprintf(stderr,"K2 - %d\d",indY);
		u =*(buffers[0]+Ysize+(indY>>1));
		
//		y1 = *(buffers[0]+1+indY);
//		indY++;
//	fprintf(stderr,"K3 - %d\d",indY);
		v = *(buffers[0]+Ysize+CbCrsize+(indY>>1));
		
		//y1 -= 16;
		u -= 128;
		v -= 128;

		r1 =  clip(( 298 * y1           + 409 * v + 128) >> 8);
		g1 = clip(( 298 * y1 - 100 * u - 208 * v + 128) >> 8);
		b1 = clip(( 298 * y1 + 516 * u           + 128) >> 8);
		 
	 /* Figure out where in memory to put the pixel */
         location = (x+vinfo.xoffset) * (vinfo.bits_per_pixel/8) +(320-y+vinfo.yoffset) * finfo.line_length;
	// format 565 RGB
//	fprintf(stderr,"YY %d  %d\n",indY, location);
	cR= (char)((g1<<3)&0b11100000)|(b1>>3) ; // g B
	cB= (char)(r1&0b11111000)|(g1>>5); //R g 
	 *(fbp + location)=cR;   
	 *(fbp + location+1)=cB;
//	fprintf(stderr,"%d\n",indY);
//	 cR=(char)((g2<<3)&0b11100000)|(b2>>3) ; // g B
//	 cB=(char)(r2&0b11111000)|(g2>>5); //R g
//	 *(fbp + location+2) = cR;
//	 *(fbp + location+3) = cB;
        }
    //    fprintf(stderr,"send frame\n");
    //   
  }
  while(retkey!='q');///!(getchar()=='q'));
//	gettimeofday(&finish,NULL);
  
    //fps=(double)(fcount)/((finish.tv_sec-start.tv_sec)+(finish.tv_usec-start.tv_usec)/1e6);
//	printf("\n%f fps, Saving collectected frames...\n",fps);
	
 pthread_join(key_thread,NULL);
 munmap(fbp, screensize);
 for(i=0;i<fcount;i++)
  {
   free(buffers[i]);
  }
  free(buffers);
  
  close(dev_fd); //cam
  close(fbfd); //fb
 return 0;
}





